{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {
    "execution": {
     "iopub.execute_input": "2020-08-13T03:44:39.643778Z",
     "iopub.status.busy": "2020-08-13T03:44:39.642273Z",
     "iopub.status.idle": "2020-08-13T03:44:52.045507Z",
     "shell.execute_reply": "2020-08-13T03:44:52.047143Z"
    },
    "papermill": {
     "duration": 12.432625,
     "end_time": "2020-08-13T03:44:52.048513",
     "exception": false,
     "start_time": "2020-08-13T03:44:39.615888",
     "status": "completed"
    },
    "tags": []
   },
   "outputs": [
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "Using TensorFlow backend.\n"
     ]
    }
   ],
   "source": [
    "import sys\n",
    "sys.path.append('..')\n",
    "from src.lucid import make_lucid_imagenet_dataset\n",
    "from src.utils import suppress, all_logging_disabled"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {
    "execution": {
     "iopub.execute_input": "2020-08-13T03:44:52.081008Z",
     "iopub.status.busy": "2020-08-13T03:44:52.079673Z",
     "iopub.status.idle": "2020-08-14T00:48:28.385194Z",
     "shell.execute_reply": "2020-08-14T00:48:28.437186Z"
    },
    "papermill": {
     "duration": 75816.381831,
     "end_time": "2020-08-14T00:48:28.442312",
     "exception": false,
     "start_time": "2020-08-13T03:44:52.060481",
     "status": "completed"
    },
    "pycharm": {
     "name": "#%%\n"
    },
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 104980 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1253532 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 132048 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1252992 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 113596 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1307980 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 127980 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1245808 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 133364 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1193532 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 110624 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1249436 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 127740 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1206024 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 86120 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1241932 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 118180 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1174228 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 121408 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1220208 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 142320 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1189724 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 143348 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1304800 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 144896 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1160020 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 114128 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1188384 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 151740 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1400796 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 149564 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1450964 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 154632 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1465788 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 160980 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1440608 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 160148 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1445464 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 160436 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1449980 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 160964 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1505700 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 166792 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1481212 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 164388 characters]\" style=\"image-rendering: pixelated;\">\n",
       "            </div></div>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<img src=\"data:image/PNG;base64,[encoded data, 1512048 characters]\" style=\"image-rendering: pixelated;\">"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<div style=\"display: flex; flex-direction: row;\"><div style=\"margin-right:10px; margin-top: 4px;\">\n",
       "              0 <br/>\n",
       "              <img src=\"data:image/PNG;base64,[encoded data, 43653 characters]